%define         codecdir %{_libdir}/codecs
%define         pre 20110412svn
%define         svn 1
%define         svnbuild 2011-04-12
%define         faad2min 1:2.6.1

Name:           mplayer
Version:        1.0
Release:        0.123.%{pre}%{?dist}
Summary:        Movie player playing most video formats and DVDs

Group:          Applications/Multimedia
%if 0%{!?_without_amr:1}
License:        GPLv3+
%else
License:        GPLv2+
%endif
URL:            http://www.mplayerhq.hu/
%if %{svn}
# run ./mplayer-snapshot.sh to get this
Source0:        mplayer-export-%{svnbuild}.tar.bz2
%else
Source0:        http://www.mplayerhq.hu/MPlayer/releases/MPlayer-%{version}%{pre}.tar.bz2
%endif
Source1:        http://www.mplayerhq.hu/MPlayer/skins/Blue-1.7.tar.bz2
Source10:       mplayer-snapshot.sh
# set defaults for Fedora
Patch2:         %{name}-config.patch
# use roff include statements instead of symlinks
Patch8:         %{name}-manlinks.patch
# erase any trace of libdvdcss
Patch14:        %{name}-nodvdcss.patch
# use system FFmpeg libraries
Patch18:        %{name}-ffmpeg.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  SDL-devel
BuildRequires:  a52dec-devel
BuildRequires:  aalib-devel
BuildRequires:  bzip2-devel
BuildRequires:  alsa-lib-devel
BuildRequires:  cdparanoia-devel
BuildRequires:  desktop-file-utils
BuildRequires:  em8300-devel
BuildRequires:  enca-devel
BuildRequires:  faad2-devel >= %{faad2min}
BuildRequires:  ffmpeg-devel >= 0.6.90-0.1.rc0
BuildRequires:  fontconfig-devel
BuildRequires:  freetype-devel >= 2.0.9
BuildRequires:  fribidi-devel
BuildRequires:  giflib-devel
BuildRequires:  gsm-devel
BuildRequires:  gtk2-devel
BuildRequires:  ladspa-devel
BuildRequires:  lame-devel
BuildRequires:  libGL-devel
BuildRequires:  libXinerama-devel
BuildRequires:  libXScrnSaver-devel
BuildRequires:  libXv-devel
BuildRequires:  libXvMC-devel
BuildRequires:  libXxf86vm-devel
BuildRequires:  libass-devel >= 0.9.10
BuildRequires:  libbluray-devel
BuildRequires:  libcaca-devel
BuildRequires:  libdca-devel
BuildRequires:  libdv-devel
BuildRequires:  libdvdnav-devel >= 4.1.3-1
BuildRequires:  libjpeg-devel
BuildRequires:  libmpcdec-devel
BuildRequires:  libmpeg2-devel
BuildRequires:  librtmp-devel
BuildRequires:  libtheora-devel
BuildRequires:  libvdpau-devel
BuildRequires:  libvorbis-devel
BuildRequires:  libvpx-devel >= 0.9.1
BuildRequires:  lirc-devel
BuildRequires:  live555-devel
BuildRequires:  lzo-devel >= 2
BuildRequires:  pulseaudio-lib-devel
BuildRequires:  speex-devel >= 1.1
BuildRequires:  twolame-devel
BuildRequires:  x264-devel >= 0.0.0-0.28
BuildRequires:  xvidcore-devel >= 0.9.2
BuildRequires:  yasm
%{?_with_arts:BuildRequires: arts-devel}
%{?_with_dga:BuildRequires: libXxf86dga-devel}
%{?_with_directfb:BuildRequires: directfb-devel}
%{?_with_esound:BuildRequires: esound-devel}
%{?_with_faac:BuildRequires:  faac-devel}
%{?_with_jack:BuildRequires: jack-audio-connection-kit-devel}
%{?_with_libmad:BuildRequires:  libmad-devel}
%{?_with_nemesi:BuildRequires:  libnemesi-devel >= 0.6.3}
%{?_with_openal:BuildRequires: openal-soft-devel}
%{?_with_samba:BuildRequires: libsmbclient-devel}
%{?_with_svgalib:BuildRequires: svgalib-devel}
%{?_with_xmms:BuildRequires: xmms-devel}
%if %{svn}
# for XML docs, SVN only
BuildRequires:  docbook-dtds
BuildRequires:  docbook-style-xsl
BuildRequires:  libxml2
BuildRequires:  libxslt
%endif
Obsoletes:      mplayer-fonts
Requires:       faad2-libs >= %{faad2min}
Requires:       mplayer-common = %{version}-%{release}

%description
MPlayer is a movie player that plays most MPEG, VOB, AVI, OGG/OGM,
VIVO, ASF/WMA/WMV, QT/MOV/MP4, FLI, RM, NuppelVideo, yuv4mpeg, FILM,
RoQ, and PVA files. You can also use it to watch VCDs, SVCDs, DVDs,
3ivx, RealMedia, and DivX movies.
It supports a wide range of output drivers including X11, XVideo, DGA,
OpenGL, SVGAlib, fbdev, AAlib, DirectFB etc. There are also nice
antialiased shaded subtitles and OSD.
Non-default rpmbuild options:
--with samba:   Enable Samba (smb://) support
--with xmms:    Enable XMMS input plugin support
--without amr:  Disable AMR support
--with faac:    Enable FAAC support
--with libmad:  Enable libmad support
--with openal:  Enable OpenAL support
--with jack:    Enable JACK support
--with arts:    Enable aRts support
--with esound:  Enable EsounD support
--with dga:     Enable DGA support
--with directfb:Enable DirectFB support
--with svgalib: Enable SVGAlib support
--with nemesi:  Enable libnemesi RTSP support

%package        common
Summary:        MPlayer common files
Group:          Applications/Multimedia

%description    common
This package contains common files for MPlayer packages.

%package        gui
Summary:        GUI for MPlayer
Group:          Applications/Multimedia
Requires:       mplayer-common = %{version}-%{release}
Requires:       hicolor-icon-theme

%description    gui
This package contains a GUI for MPlayer and a default skin for it.

%package     -n mencoder
Summary:        MPlayer movie encoder
Group:          Applications/Multimedia
Requires:       mplayer-common = %{version}-%{release}

%description -n mencoder
This package contains the MPlayer movie encoder. 

%package        doc
Summary:        MPlayer documentation in various languages
Group:          Documentation

%description    doc
MPlayer documentation in various languages.

%package        tools
Summary:        Useful scripts for MPlayer
Group:          Applications/Multimedia
Requires:       mencoder = %{version}-%{release}
Requires:       mplayer = %{version}-%{release}

%description    tools
This package contains various scripts from MPlayer TOOLS directory.

%define mp_configure \
./configure \\\
    --prefix=%{_prefix} \\\
    --bindir=%{_bindir} \\\
    --datadir=%{_datadir}/mplayer \\\
    --mandir=%{_mandir} \\\
    --confdir=%{_sysconfdir}/mplayer \\\
    --libdir=%{_libdir} \\\
    --codecsdir=%{codecdir} \\\
    \\\
    --extra-cflags="$RPM_OPT_FLAGS" \\\
    --language=all \\\
    \\\
    --enable-joystick \\\
    --enable-largefiles \\\
    --enable-lirc \\\
    --enable-menu \\\
    --enable-radio \\\
    --enable-radio-capture \\\
    --enable-runtime-cpudetection \\\
    --enable-unrarexec \\\
    \\\
    --disable-dvdread-internal \\\
    --disable-libdvdcss-internal \\\
    %{!?_with_nemesi:--disable-nemesi} \\\
    %{!?_with_samba:--disable-smb} \\\
    \\\
    --disable-ffmpeg_a \\\
    \\\
    %{?_without_amr:--disable-libopencore_amrnb --disable-libopencore_amrwb} \\\
    %{!?_with_faac:--disable-faac} \\\
    %{!?_with_libmad:--disable-mad} \\\
    --disable-libmpeg2-internal \\\
    --disable-tremor-internal \\\
    %{?_with_xmms:--enable-xmms} \\\
    %{?_with_xmms:--with-xmmslibdir=%{_libdir}} \\\
    \\\
    --disable-bitmap-font \\\
    %{!?_with_dga:--disable-dga1 --disable-dga2} \\\
    --%{?_with_directfb:enable}%{!?_with_directfb:disable}-directfb \\\
    %{!?_with_svgalib:--disable-svga} \\\
    --disable-termcap \\\
    --enable-xvmc \\\
    --with-xvmclib=XvMCW \\\
    \\\
    %{!?_with_arts:--disable-arts} \\\
    %{!?_with_esound:--disable-esd} \\\
    %{!?_with_jack:--disable-jack} \\\
    %{!?_with_openal:--disable-openal} \\\
    --disable-mp3lib \\\


%prep
%if %{svn}
%setup -q -n mplayer-export-%{svnbuild}
%else
%setup -q -n MPlayer-%{version}%{pre}
%endif
%patch2 -p1 -b .config
%patch8 -p1 -b .manlinks
%patch14 -p1 -b .nodvdcss
%patch18 -p1 -b .ffmpeg

doconv() {
    iconv -f $1 -t $2 -o DOCS/man/$3/mplayer.1.utf8 DOCS/man/$3/mplayer.1 && \
    mv DOCS/man/$3/mplayer.1.utf8 DOCS/man/$3/mplayer.1
}
for lang in de es fr it ; do doconv iso-8859-1 utf-8 $lang ; done
for lang in hu pl ; do doconv iso-8859-2 utf-8 $lang ; done
for lang in ru ; do doconv koi8-r utf-8 $lang ; done

mkdir GUI
cp -a `ls -1|grep -v GUI` GUI/

%build
pushd GUI
%{mp_configure}--enable-gui --disable-mencoder

%{__make} V=1 %{?_smp_mflags}
popd

%{mp_configure}

%{__make} V=1 %{?_smp_mflags}

%if %{svn}
# build HTML documentation from XML files 
pushd DOCS/xml
%{__make} html-chunked
popd
%endif

%install
rm -rf $RPM_BUILD_ROOT doc

make install DESTDIR=$RPM_BUILD_ROOT INSTALLSTRIP=
for file in aconvert.sh divx2svcd.sh mencvcd.sh midentify.sh mpconsole.sh qepdvcd.sh subsearch.sh ; do
install -pm 755 TOOLS/$file $RPM_BUILD_ROOT%{_bindir}/`basename $file .sh`
done

for file in calcbpp.pl countquant.pl dvd2divxscript.pl ; do
install -pm 755 TOOLS/$file $RPM_BUILD_ROOT%{_bindir}/`basename $file .pl`
done

for file in vobshift.py ; do
install -pm 755 TOOLS/$file $RPM_BUILD_ROOT%{_bindir}/`basename $file .py`
done

mkdir -p $RPM_BUILD_ROOT%{_datadir}/mplayer
install -pm 644 TOOLS/*.fp $RPM_BUILD_ROOT%{_datadir}/mplayer/

# Clean up documentation
mkdir doc
cp -pR DOCS/* doc/
rm -r doc/man doc/xml doc/README
mv doc/HTML/* doc/
rm -rf doc/HTML

# Default config files
install -Dpm 644 etc/example.conf \
    $RPM_BUILD_ROOT%{_sysconfdir}/mplayer/mplayer.conf

install -pm 644 etc/{input,menu}.conf $RPM_BUILD_ROOT%{_sysconfdir}/mplayer/

# GUI mplayer
install -pm 755 GUI/%{name} $RPM_BUILD_ROOT%{_bindir}/gmplayer

# Default skin
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/mplayer/skins
tar xjC $RPM_BUILD_ROOT%{_datadir}/mplayer/skins --exclude=.svn -f %{SOURCE1}
ln -s Blue $RPM_BUILD_ROOT%{_datadir}/mplayer/skins/default

# Icons
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps
install -pm 644 etc/mplayer.xpm \
    $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps

# Desktop file
desktop-file-install \
        --vendor livna \
        --dir $RPM_BUILD_ROOT%{_datadir}/applications \
        etc/%{name}.desktop

# Codec dir
install -dm 755 $RPM_BUILD_ROOT%{codecdir}


%post gui
gtk-update-icon-cache -qf %{_datadir}/icons/hicolor &>/dev/null || :
update-desktop-database &>/dev/null || :


%postun gui
gtk-update-icon-cache -qf %{_datadir}/icons/hicolor &>/dev/null || :
update-desktop-database &>/dev/null || :


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-, root, root, -)
%{_bindir}/mplayer

%files common
%defattr(-, root, root, -)
%doc AUTHORS Changelog Copyright LICENSE README
%dir %{_sysconfdir}/mplayer
%config(noreplace) %{_sysconfdir}/mplayer/mplayer.conf
%config(noreplace) %{_sysconfdir}/mplayer/input.conf
%config(noreplace) %{_sysconfdir}/mplayer/menu.conf
%dir %{codecdir}/
%dir %{_datadir}/mplayer/
%{_mandir}/man1/mplayer.1*
%lang(cs) %{_mandir}/cs/man1/mplayer.1*
%lang(de) %{_mandir}/de/man1/mplayer.1*
%lang(es) %{_mandir}/es/man1/mplayer.1*
%lang(fr) %{_mandir}/fr/man1/mplayer.1*
%lang(hu) %{_mandir}/hu/man1/mplayer.1*
%lang(it) %{_mandir}/it/man1/mplayer.1*
%lang(pl) %{_mandir}/pl/man1/mplayer.1*
%lang(ru) %{_mandir}/ru/man1/mplayer.1*
%lang(zh_CN) %{_mandir}/zh_CN/man1/mplayer.1*

%files gui
%defattr(-, root, root, -)
%{_bindir}/gmplayer
%{_datadir}/applications/*mplayer.desktop
%{_datadir}/icons/hicolor/32x32/apps/mplayer.xpm
%{_datadir}/mplayer/skins/

%files -n mencoder
%defattr(-, root, root, -)
%{_bindir}/mencoder
%{_mandir}/man1/mencoder.1*
%lang(cs) %{_mandir}/cs/man1/mencoder.1*
%lang(de) %{_mandir}/de/man1/mencoder.1*
%lang(es) %{_mandir}/es/man1/mencoder.1*
%lang(fr) %{_mandir}/fr/man1/mencoder.1*
%lang(hu) %{_mandir}/hu/man1/mencoder.1*
%lang(it) %{_mandir}/it/man1/mencoder.1*
%lang(pl) %{_mandir}/pl/man1/mencoder.1*
%lang(ru) %{_mandir}/ru/man1/mencoder.1*
%lang(zh_CN) %{_mandir}/zh_CN/man1/mencoder.1*

%files doc
%defattr(-, root, root, -)
%doc doc/en/ doc/tech/
%lang(cs) %doc doc/cs/
%lang(de) %doc doc/de/
%lang(es) %doc doc/es/
%lang(fr) %doc doc/fr/
%lang(hu) %doc doc/hu/
%lang(pl) %doc doc/pl/
%lang(ru) %doc doc/ru/
%lang(zh_CN) %doc doc/zh_CN/

%files tools
%defattr(-, root, root, -)
%{_bindir}/aconvert
%{_bindir}/calcbpp
%{_bindir}/countquant
%{_bindir}/divx2svcd
%{_bindir}/dvd2divxscript
%{_bindir}/mencvcd
%{_bindir}/midentify
%{_bindir}/mpconsole
%{_bindir}/qepdvcd
%{_bindir}/subsearch
%{_bindir}/vobshift
%{_datadir}/mplayer/*.fp

%changelog
* Thu Feb 02 2012 Andrew Wyatt <andrew@fuduntu.org> - 1.0-0.123.
- Built for Fuduntu

* Thu Feb 02 2012 Andrew Wyatt <andrew@fuduntu.org> - 1.0-0.123.20110412svn
- Built for Fuduntu

* Tue Apr 12 2011 Dominik Mierzejewski <rpm at greysector.net> - 1.0-0.123.20110412svn
- 20110412 snapshot
- drop obsolete libvorbis patch
- add explanatory comments to all patches
- temporarily disable mp3lib decoder (workaround for bug #1680)

* Sun Mar 27 2011 Dominik Mierzejewski <rpm at greysector.net> - 1.0-0.122.20110227svn
- 20110227 snapshot
- rebuilt for new ffmpeg and x264

* Sun Mar 27 2011 Nicolas Chauvet <kwizart@gmail.com> - 1.0-0.121.20110110svn
- Rebuild for x264

* Mon Jan 10 2011 Dominik Mierzejewski <rpm at greysector.net> - 1.0-0.120.20110110svn
- 20110110 snapshot
- enabled BluRay, bzip2, libgsm, rtmp support
- DGA support is now a build-time option
- build against system FFmpeg (experimental!)
  (drop direct opencore-amr and schroedinger linking)
